SLASH_LH1 = "/LootHistory";
SLASH_LH2 = "/LH";
LootHistoryVersion = "LootHistory v0.1";

function AddLootHistory(arg1)	
	local s = string.find(arg1, "%|");
	local e = string.find(arg1, "%|h%|r");	
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(string.sub(arg1, s, e));
	local userName = string.sub(arg1, 0, (string.find(arg1, " ")-1));
	--ChatFrame1:AddMessage("Item: "..tostring(itemLink) .." username: "..tostring(userName).." itemType: "..tostring(itemType).." itemRarity:"..tostring(itemRarity));
	if (not(itemType == "Money")) and ((itemRarity >=2) and (itemRarity <=6)) then
		if LootHistory[userName] == nil then
			LootHistory[userName]={};
		end
		tinsert(LootHistory[userName], itemLink);
		--ChatFrame1:AddMessage("added");
	end
end

function AddLootHistory2(userName, itemLink)
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
	ChatFrame1:AddMessage(LootHistoryVersion.. " - AddLootHistory");
	ChatFrame1:AddMessage(userName ..": "..itemLink.." successfully added");
	if LootHistory[userName] == nil then
		LootHistory[userName]={};
	end
	tinsert(LootHistory[userName], itemLink);
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
end

function RemoveLootHistory(userName, i)
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
	ChatFrame1:AddMessage(LootHistoryVersion.. " - RemoveLootHistory");	
	if not(LootHistory[userName] == nil) then		
		if (i<=#LootHistory[userName]) and (i>=0) then
			tremove(LootHistory[userName], i);
			ChatFrame1:AddMessage(userName ..": "..itemLink.." successfully removed");
		end
	end
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
end

function RemoveLootHistory2(userName, itemLink)
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
	ChatFrame1:AddMessage(LootHistoryVersion.. " - RemoveLootHistory");	
	if not(LootHistory[userName] == nil) then		
		local x = -1;
		for i, iLink in ipairs(LootHistory[userName]) do
			if iLink == itemLink then
				x=i;
			end
		end
		if (x<=#LootHistory[userName]) and (x>=0) then			
			tremove(LootHistory[userName], x);
			ChatFrame1:AddMessage(userName ..": "..itemLink.." successfully removed");
		end
	end
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
end

function GetLootHistory()
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
	ChatFrame1:AddMessage(LootHistoryVersion.. " - GetLootHistory");	
	for userName, i in pairs(LootHistory) do
		for i, itemLink in ipairs(LootHistory[userName]) do
			ChatFrame1:AddMessage(userName ..": "..itemLink);
		end
	end
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
end

function GetPlayerLootHistory(userName)
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
	ChatFrame1:AddMessage(LootHistoryVersion.. " - GetPlayerLootHistory");
	ChatFrame1:AddMessage("LootHistory of "..userName..":");
	if not(LootHistory[userName] == nil) then
		for i, itemLink in ipairs(LootHistory[userName]) do
			ChatFrame1:AddMessage(userName ..": "..itemLink);
		end
	end
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
end

function ClearLootHistory()
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
	ChatFrame1:AddMessage(LootHistoryVersion.. " - ClearLootHistory");
	ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
	wipe(LootHistory);
end

function LootHistoryOnEvent(self, event, ...)	
	if event == "ADDON_LOADED" and arg1 == "LootHistory" then		
		if LootHistory == nil then
			LootHistory = {};
		end
	end
	if event == "CHAT_MSG_LOOT" then
		ChatFrame1:AddMessage(event);
		ChatFrame1:AddMessage(arg1);
		if strfind(arg1, "Beute:") then
			AddLootHistory(arg1);
		end
		--[[if strfind(arg1, "Gegenstand:") then
			AddLootHistory(arg1);
		end]]--
	end
end	

LootHistoryFrame = CreateFrame("FRAME", "LootHistoryFrame", UIParent);
LootHistoryFrame:RegisterEvent("ADDON_LOADED");
LootHistoryFrame:RegisterEvent("CHAT_MSG_LOOT");
LootHistoryFrame:SetScript("OnEvent", LootHistoryOnEvent);
LootHistoryFrame:Hide();

SlashCmdList["LH"] = function(param)
	local param1
	local s, e = string.find(param, " ");
	if s == nil then
		param1=" ";
		if (param == "toggle") or (string.len(param) == 0) then
		ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		ChatFrame1:AddMessage(LootHistoryVersion);
		ChatFrame1:AddMessage("/lh [command]");
		ChatFrame1:AddMessage("/loohistory [command]");
		ChatFrame1:AddMessage("available commands:");
		ChatFrame1:AddMessage("[get] - shows you the current loot history");
		ChatFrame1:AddMessage("[clear] - wipes the loot history");
		ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		elseif param == "clear" then
			ClearLootHistory();
		elseif param == "get" then
			GetLootHistory();
		end		
	else
		param1 = string.sub(param, 0, e-1);
	end	
	if param1 == "add" then
		local args = {};
		local i = 0;
		local params = string.sub(param, e+1);
		s, e = string.find(params, " ");
		while (not(e == nil)) and (not(i >= 2)) do
			args[i]=string.sub(params, 0, e-1);			
			params = string.sub(params, e+1);
			s, e = string.find(params, " ");
			i=i+1;
		end
		if (not(i==0)) and (not(i >= 2)) and (not (string.sub(params, 0) == "")) then
			args[i]=string.sub(params, 0);
		end		
		if (#args == 1) and (not(i >= 2)) then
			AddLootHistory2(args[0], args[1]);
		end
	elseif param1 == "remove" then
		local args = {};
		local i = 0;
		local params = string.sub(param, e+1);
		s, e = string.find(params, " ");
		while (not(e == nil)) and (not(i >= 2)) do
			args[i]=string.sub(params, 0, e-1);			
			params = string.sub(params, e+1);
			s, e = string.find(params, " ");
			i=i+1;
		end
		if (not(i==0)) and (not(i >= 2)) and (not (string.sub(params, 0) == "")) then
			args[i]=string.sub(params, 0);
		end		
		if (#args == 1) and (not(i >= 2)) then
			RemoveLootHistory2(args[0], args[1]);
		end
	elseif param1 == "get" then
		local args = {};		
		local params = string.sub(param, e+1);
		s, e = string.find(params, " ");		
		if (e == nil) and (not (string.sub(params, 0) == "")) then			
			args[0]=string.sub(params, 0);
		end		
		if (#args == 0) and not(args[0] == nil) and e == nil then
			--ChatFrame1:AddMessage("GetPlayerLootHistory("..tostring(args[0])..")");
			GetPlayerLootHistory(args[0]);
		end
	end	
end